///////////////////////////////////////////////
//Lösung zu Aufgabe 1 im Kapitel Turtlegrafik
////////////////////////////////////////////////


// Zustand der Turtle
float actX; // aktuelle Position
float actY;
float actW; // aktueller Winkel
color actC=color(0);  // Farbe
boolean penIsDown; // Stift is unten (es wird gemalt)

// gloable Variablen: 
// Fenstergröße
int w=1000;
int h=1000;

// Ausgangsseitenlänge des Quadats
float laenge = 10;

// Anfangsfarbe:
float hue = 0;

///////////////////////////////////////////////////////////

void settings() {
  size(w, h);
}

void setup() {
  colorMode(HSB,100);
  iniTurtle();
  move(500);
  turn(90);
  move(500);
  turn(-90);
  penDown();
}

///////////////////////////////////////////////////////////

void draw() {
  drawCommands();

  // Farbe alle 100 Striche wechseln
  if (frameCount % 100 == 0) 
    setColor(color(random(0,100),100,100));
  
  // Abbruch nach 10000 Strichen
  if (frameCount > 10000) noLoop();
}

///////////////////////////////////////////////////////////

void drawCommands() {
  turn(random(0,360));
  move(10);
}

///////////////////////////////////////////////////////////
//
// Turtle Kommandos
//
///////////////////////////////////////////////////////////

void iniTurtle() {
  actX=0;
  actY=0;
  actW=0;
  setColor(color(0,0,0));
  penIsDown = false;
  // Hintergrund weiß im HSB Modell
  background(0,0,100);
}

void move(float len) {
  // drehe die Turtle auf den aktuellen Winkel
  float dx = cos(radians(actW))*len;
  float dy = sin(radians(actW))*len;
  if (penIsDown) 
     line(actX,height-actY,actX+dx,height-(actY+dy));
  // bewege Turtle weiter
  actX+=dx;
  actY+=dy;
}

void turn(float ang) { actW += ang; }
void setColor(color c) { actC = c; stroke(actC); }
void penUp() { penIsDown = false; }
void penDown() { penIsDown = true; }